module rgb2ycbcr(
	clk,
	rst_n,
	rgb888_r,
	rgb888_g,
	rgb888_b,
	img_y,
	img_cb,
	img_cr);

	//---Ports declearation: generated by Robei---
	input clk;
	input rst_n;
	input [7:0] rgb888_r;
	input [7:0] rgb888_g;
	input [7:0] rgb888_b;
	output [7:0] img_y;
	output [7:0] img_cb;
	output [7:0] img_cr;

	wire clk;
	wire rst_n;
	wire [7:0] rgb888_r;
	wire [7:0] rgb888_g;
	wire [7:0] rgb888_b;
	wire [7:0] img_y;
	wire [7:0] img_cb;
	wire [7:0] img_cr;

	//----Code starts here: integrated by Robei-----
	//reg define
	  reg  [15:0]   rgb_r_m0, rgb_r_m1, rgb_r_m2;
	  reg  [15:0]   rgb_g_m0, rgb_g_m1, rgb_g_m2;
	  reg  [15:0]   rgb_b_m0, rgb_b_m1, rgb_b_m2;
	  reg  [15:0]   img_y0 ;
	  reg  [15:0]   img_cb0;
	  reg  [15:0]   img_cr0;
	  reg  [ 7:0]   img_y1 ;
	  reg  [ 7:0]   img_cb1;
	  reg  [ 7:0]   img_cr1;
	
	
	  assign img_y            =  img_y1 ;
	  assign img_cb           =  img_cb1;
	  assign img_cr           =  img_cr1;
	  
	  
	  //step1 mult
	  always @(posedge clk or negedge rst_n) begin
	      if(!rst_n) begin
	          rgb_r_m0 <= 16'd0;
	          rgb_r_m1 <= 16'd0;
	          rgb_r_m2 <= 16'd0;
	          rgb_g_m0 <= 16'd0;
	          rgb_g_m1 <= 16'd0;
	          rgb_g_m2 <= 16'd0;
	          rgb_b_m0 <= 16'd0;
	          rgb_b_m1 <= 16'd0;
	          rgb_b_m2 <= 16'd0;
	      end
	      else begin
	          rgb_r_m0 <= rgb888_r * 8'd77 ;
	          rgb_r_m1 <= rgb888_r * 8'd43 ;
	          rgb_r_m2 <= rgb888_r << 3'd7 ;
	          rgb_g_m0 <= rgb888_g * 8'd150;
	          rgb_g_m1 <= rgb888_g * 8'd85 ;
	          rgb_g_m2 <= rgb888_g * 8'd107;
	          rgb_b_m0 <= rgb888_b * 8'd29 ;
	          rgb_b_m1 <= rgb888_b << 3'd7 ;
	          rgb_b_m2 <= rgb888_b * 8'd21 ;
	     end
	 end
	 
	 //step2 add
	 always @(posedge clk or negedge rst_n) begin
	     if(!rst_n) begin
	         img_y0  <= 16'd0;
	         img_cb0 <= 16'd0;
	         img_cr0 <= 16'd0;
	     end
	     else begin
	         img_y0  <= rgb_r_m0 + rgb_g_m0 + rgb_b_m0;
	         img_cb0 <= rgb_b_m1 - rgb_r_m1 - rgb_g_m1 + 16'd32768;
	         img_cr0 <= rgb_r_m2 - rgb_g_m2 - rgb_b_m2 + 16'd32768;
	     end
	 
	 end
	 
	 //step3 div
	 always @(posedge clk or negedge rst_n) begin
	     if(!rst_n) begin
	         img_y1  <= 8'd0;
	         img_cb1 <= 8'd0;
	         img_cr1 <= 8'd0;
	     end
	     else begin
	         img_y1  <= img_y0 [15:8];
	         img_cb1 <= img_cb0[15:8];
	         img_cr1 <= img_cr0[15:8];
	     end
	 end
	 
	
	 
	 
	
	
	
	
endmodule    //rgb2ycbcr

